#include"audio.h"


Mix_Music *bgm=NULL;	//BGM


void PlayBgm(const char *filename){
	if(bgm!=NULL){StopBgm();}
	bgm = Mix_LoadMUS(filename);
	Mix_PlayMusic(bgm, -1);
}
void StopBgm(void){
	Mix_HaltMusic();
	Mix_FreeMusic(bgm);
	bgm = NULL;
}



//サウンド読み込み
void LoadSound(SOUND *sound, const char *filename){
	sound->channel = 0;
	sound->chunk = Mix_LoadWAV(filename);
}
//サウンド再生
void PlaySound(SOUND *sound){
	sound->channel = Mix_PlayChannel(-1, sound->chunk, 0);
}
//サウンド解放
void FreeSound(SOUND *sound){
	Mix_HaltChannel(sound->channel);
	Mix_FreeChunk(sound->chunk);
}

void LoadSoundPac(SOUNDPAC *soundpac){
	LoadSound(&soundpac->select, "data/sound/select.wav");
	LoadSound(&soundpac->start, "data/sound/start.wav");
	LoadSound(&soundpac->gun_shot, "data/sound/gun_shot.wav");
	LoadSound(&soundpac->gun_damage, "data/sound/gun_damage.wav");
	LoadSound(&soundpac->bom_set, "data/sound/bom_set.wav");
	LoadSound(&soundpac->bom, "data/sound/bom.wav");
	LoadSound(&soundpac->bom_damage, "data/sound/bom_damage.wav");
	LoadSound(&soundpac->item, "data/sound/item.wav");
	LoadSound(&soundpac->dead, "data/sound/dead.wav");
	LoadSound(&soundpac->tyoudan[0], "data/sound/tyoudan001.wav");
	LoadSound(&soundpac->tyoudan[1], "data/sound/tyoudan002.wav");
	LoadSound(&soundpac->tyoudan[2], "data/sound/tyoudan003.wav");
}
void FreeSoundPac(SOUNDPAC *soundpac){
	FreeSound(&soundpac->select);
	FreeSound(&soundpac->start);
	FreeSound(&soundpac->gun_shot);
	FreeSound(&soundpac->gun_damage);
	FreeSound(&soundpac->bom_set);
	FreeSound(&soundpac->bom);
	FreeSound(&soundpac->bom_damage);
	FreeSound(&soundpac->item);
	FreeSound(&soundpac->dead);
	FreeSound(&soundpac->tyoudan[0]);
	FreeSound(&soundpac->tyoudan[1]);
	FreeSound(&soundpac->tyoudan[2]);
}
