#ifndef _AUDIO_H
#define _AUDIO_H

#include<SDL/SDL.h>
#include<SDL/SDL_mixer.h>

//サウンド用構造体
typedef struct SOUND{
	Mix_Chunk *chunk;
	int channel;
}SOUND;

typedef struct SOUNDPAC{
	SOUND select;
	SOUND start;
	SOUND gun_shot;
	SOUND gun_damage;
	SOUND bom_set;
	SOUND bom;
	SOUND bom_damage;
	SOUND item;
	SOUND dead;
	SOUND tyoudan[3];
}SOUNDPAC;


void PlayBgm(const char *filename);
void StopBgm(void);

void LoadSound(SOUND *sound, const char *filename);
void PlaySound(SOUND *sound);
void FreeSound(SOUND *sound);

void LoadSoundPac(SOUNDPAC *soundpac);
void FreeSoundPac(SOUNDPAC *soundpac);


#endif
