#ifndef _CHARA_H
#define _CHARA_H

#include<SDL/SDL.h>
#include<stdlib.h>
#include<time.h>
#include<math.h>
#include"main.h"
#include"map.h"
#include"weapon.h"
#include"support.h"


//キーフラグ
typedef unsigned char KEY_FLG;
//キーフラグビット
#define KFLG_D_w	0x01	//Wキー ダウン
#define KFLG_D_s	0x02	//Sキー ダウン
#define KFLG_D_a	0x04	//Aキー ダウン
#define KFLG_D_d	0x08	//Dキー ダウン

#define KFLG_U_w	0xfe	//Wキー アップ
#define KFLG_U_s	0xfd	//Sキー アップ
#define KFLG_U_a	0xfb	//Aキー アップ
#define KFLG_U_d	0xf7	//Dキー アップ

//マウスボタンフラグビット
#define MBT_D_LEFT	0x01	//左ボタン ダウン
#define MBT_D_RIGHT	0x02	//右ボタン ダウン

#define MBT_U_LEFT	0xfe	//左ボタン アップ
#define MBT_U_RIGHT	0xfd	//右ボタン アップ

//キャラクタの位置
#define PL_X	144
#define PL_Y	104


//typedef struct PLAYER{
//	int hp;			//体力
//	unsigned char muki;	//向き(上から時計回り 0~7)
//	unsigned char koma;	//アニメのコマ
//	unsigned char wepflg;	//武器フラグ
//	int mg_ammo;		//マシンガン弾薬数
//	int bom_ammo;		//ボム数
//	unsigned char flg;	//状態フラグ(0:死亡 1:通常 2:射撃 3:ダメージ 4:爆発)
//	int wait;			//待ち時間
//	int score;	//スコア
//}PLAYER;

//キャラ移動量
typedef struct PL_MOVE{
	int x;	//x成分
	int y;	//y成分
	unsigned char flg;	//フラグ(0:移動なし 1:移動あり)
}PL_MOVE;

//マウス情報
typedef struct MOUSE_PARAM{
	int x;	//x座標
	int y;	//y座標
	unsigned char bt;	//ボタンフラグ
}MOUSE_PARAM;

PL_MOVE MovePlayer(PLAYER *player, LMAP *lmap, WMAP wmap, KEY_FLG key_flg);
void DrawPlayer(SDL_Surface *screen, SDL_Surface *img, PLAYER player);
void MoveCursor(PLAYER *player, LMAP lmap, MOUSE_PARAM mouse_param);
void DrawCursor(SDL_Surface *screen, SDL_Surface *img, PLAYER player, MOUSE_PARAM mouse_param);
int CharaTurnCursor(int cx, int cy);
int GetMuki(int x1, int y1, int x2, int y2);
void DrawState(SDL_Surface *screen, SDL_Surface *img, PLAYER player, int floor);
void DrawWepSelect(SDL_Surface *screen, SDL_Surface *img, PLAYER player);
void DrawNum(SDL_Surface *screen, int x, int y, unsigned long num, SDL_Surface *img);


#endif
