#include"enemy.h"


ENEMY enemy_head;	//敵ヘッド


//敵=================================================================================
//敵作成
void MakeEnemy(int x, int y, unsigned char type){
	ENEMY *lpNew, *lp;

	if(( lpNew = (ENEMY *)malloc(sizeof(ENEMY)) ) == NULL){
		printf("敵作成・・・メモリ乙\n");
		exit(0);
	}

	lpNew->x = x;		//x座標
	lpNew->y = y;		//y座標
	lpNew->hp = EN_HP;	//体力
	lpNew->muki = random()%8;	//向き(上から時計回り 0~7)
	lpNew->koma = 10;		//アニメのコマ
	lpNew->flg = 1;		//状態フラグ(0:消去 1:通常 2:射撃 3:ダメージ 4:爆発)
	lpNew->move_flg = 1;	//移動処理を行うかのフラグ
	lpNew->wait = 0;		//待ち時間
	lpNew->found_flg = 0;	//発見フラグ(0:通常 1:発見)
	lpNew->found_time = 0;	//発見状態から通常状態に戻る時間
	lpNew->tobi_wait = 0;	//ふっ飛び待ち時間
	lpNew->tobi_muki = 0;	//ふっ飛ぶ向き(向きと〃様な内容)
	lpNew->type = type;	//キャラクタの性格(0:単発 1:連射 2:ボム)
	lpNew->next = NULL;

	lp = &enemy_head;
	while(lp->next != NULL){
		lp = lp->next;
	}

	lp->next = lpNew;	
}
//敵制御　総括
void MoveEnemy(WMAP wmap, LMAP lmap, int mx, int my, unsigned char flg){
	ENEMY *lp;
	HITPARAM hitparam;
	int i;

	for(lp=enemy_head.next; lp!=NULL; lp=lp->next){
		if(flg){lp->x-=mx; lp->y-=my;}

		//個別の行動
		if(lp->flg==1 || lp->flg==2){
			if(lp->type == 0){MoveEnemyTypeA(wmap, lmap, lp);}		//ハンドガン
			else if(lp->type == 1){MoveEnemyTypeB(wmap, lmap, lp);}	//マシンガン
			else if(lp->type == 2){MoveEnemyTypeC(wmap, lmap, lp);}	//ボム
			else if(lp->type == 3){MoveEnemyTypeD(wmap, lmap, lp);}	//ターゲット
		}
		//ダメージ（ふっ飛び）
		else if(lp->flg==3){
			if(lp->tobi_muki==7 || lp->tobi_muki==0 || lp->tobi_muki==1){//上-------------
				lp->y-=BOM_TOBI_SP;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+10);
					if(hitparam.flg){lp->y+=32-hitparam.y; break;}
				}
			}
			if(lp->tobi_muki==3 || lp->tobi_muki==4 || lp->tobi_muki==5){//下---------------
				lp->y+=BOM_TOBI_SP;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+31);
					if(hitparam.flg){lp->y-=hitparam.y+1; break;}
				}
			}
			if(lp->tobi_muki==5 || lp->tobi_muki==6 || lp->tobi_muki==7){//左-------------
				lp->x-=BOM_TOBI_SP;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+5, lp->y+i);
					if(hitparam.flg){lp->x+=32-hitparam.x; break;}
				}
			}
			if(lp->tobi_muki==1 || lp->tobi_muki==2 || lp->tobi_muki==3){//右-------------
				lp->x+=BOM_TOBI_SP;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+26, lp->y+i);
					if(hitparam.flg){lp->x-=hitparam.x+1; break;}
				}
			}
			lp->tobi_wait--;
			if(lp->tobi_wait <= 0){lp->flg = 1;}
		}
		//爆発
		else if(lp->flg==4){
			lp->koma++;
			if(lp->koma >= 16){
				lp->flg = 0;
				//マシンガン||ボムなら、一定の確立でアンモドロップ
				if(lp->type==1 || lp->type==2){
					if(!(random()%8)){MakeItem(lp->x+8,lp->y+8,0);}
				}
			}
		}
	}

}
//敵制御A	ハンドガンタイプ
void MoveEnemyTypeA(WMAP wmap, LMAP lmap, ENEMY *lp){
	int i;
	unsigned char hitflg;	//何かしら壁にあたったらON
	HITPARAM hitparam;
	int rx, ry;


	//通常--------------------------------------
	if(lp->flg == 1){
		//キャラ発見時
		if(lp->found_flg == 1){
			lp->muki = GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16);	//常にプレーヤーを捕捉
			//射撃
			//画面内になるべく移動
			if(HitRect(20,20,VIDEO_W-40,VIDEO_H-40, lp->x,lp->y,32,32) == 0){
				if(lp->muki==7 || lp->muki==0 || lp->muki==1){//上-------------
					lp->y-=1;
					for(i=5; i<27; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+10);
						if(hitparam.flg){lp->y+=32-hitparam.y; hitflg=1; break;}
					}
				}
				if(lp->muki==3 || lp->muki==4 || lp->muki==5){//下---------------
					lp->y+=1;
					for(i=5; i<27; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+31);
						if(hitparam.flg){lp->y-=hitparam.y+1; hitflg=1; break;}
					}
				}
				if(lp->muki==5 || lp->muki==6 || lp->muki==7){//左-------------
					lp->x-=1;
					for(i=10; i<32; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+5, lp->y+i);
						if(hitparam.flg){lp->x+=32-hitparam.x; hitflg=1; break;}
					}
				}
				if(lp->muki==1 || lp->muki==2 || lp->muki==3){//右-------------
					lp->x+=1;
					for(i=10; i<32; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+26, lp->y+i);
						if(hitparam.flg){lp->x-=hitparam.x+1; hitflg=1; break;}
					}
				}
				lp->koma = (lp->koma+1)%40;
			}else{lp->koma = 10;}
			if(lp->wait <= 0){
				lp->wait = (random()%10)*(FPS/2);	//次弾発射までのウェイトを設定
				lp->flg = 2;	//[射撃]状態
				lp->koma = 0;
				rx = PL_X-18 + random()%51;	//狙う位置を定める
				ry = PL_Y-18 + random()%51;	//	〃
				hitparam = HitWmapLine(wmap, lmap, lp->x+16, lp->y+20, rx, ry);	//壁にあたってないか判定
				if(hitparam.flg){rx=hitparam.x; ry=hitparam.y;}	//あたってたら着弾点を修正
				MakeBullet(rx, ry, TEAM_E);	//弾丸発射
			}else{lp->wait--;}
			//見失う判定（再発見あり）
			lp->found_time--;
			if(lp->found_time <= 0){
				hitparam = HitWmapLine(wmap, lmap,lp->x+16,lp->y+16,PL_X+16,PL_Y+16);
				if(hitparam.flg == 0){	//間に壁がなければ・・・
					lp->found_time = EN_FOUND_TIME * FPS;	//発見時間追加
				}else{	//もし、見失っていたら・・・
					lp->found_flg = 0;	//発見モード解除
				}
			}
		}
		//通常時
		else{
			//移動処理
			hitflg = 0;
			if(lp->muki==7 || lp->muki==0 || lp->muki==1){//上-------------
				lp->y-=1;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+10);
					if(hitparam.flg){lp->y+=32-hitparam.y; hitflg=1; break;}
				}
			}
			if(lp->muki==3 || lp->muki==4 || lp->muki==5){//下---------------
				lp->y+=1;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+31);
					if(hitparam.flg){lp->y-=hitparam.y+1; hitflg=1; break;}
				}
			}
			if(lp->muki==5 || lp->muki==6 || lp->muki==7){//左-------------
				lp->x-=1;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+5, lp->y+i);
					if(hitparam.flg){lp->x+=32-hitparam.x; hitflg=1; break;}
				}
			}
			if(lp->muki==1 || lp->muki==2 || lp->muki==3){//右-------------
				lp->x+=1;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+26, lp->y+i);
					if(hitparam.flg){lp->x-=hitparam.x+1; hitflg=1; break;}
				}
			}
			//壁にあたったら方向転換
			if(hitflg){lp->muki = random()%8;}
			lp->koma = (lp->koma+1)%40;
			//プレーヤー周辺なら行動
			if(HitRect(0,0,VIDEO_W,VIDEO_H, lp->x,lp->y,32,32)){
				//索敵処理
				if(lp->muki == GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16)){	//向いてる方向にキャラがいて・・・
					hitparam = HitWmapLine(wmap, lmap,lp->x+16,lp->y+16,PL_X+16,PL_Y+16);
					if(hitparam.flg == 0){	//間に壁がなければ・・・
						lp->found_flg = 1;	//発見!!!!
						lp->found_time = EN_FOUND_TIME * FPS;
					}
				}
			}
		}
	}
	//射撃--------------------------------------
	else if(lp->flg == 2){
		lp->koma++;	//アニメのコマを進めるだけの処理
		if(lp->koma >= 12){lp->flg = 1;}	//[射撃]状態解除
	}
}
//敵制御B	マシンガンタイプ
void MoveEnemyTypeB(WMAP wmap, LMAP lmap, ENEMY *lp){
	int i;
	unsigned char hitflg;	//何かしら壁にあたったらON
	HITPARAM hitparam;
	int rx, ry;

	//通常--------------------------------------
	if(lp->flg == 1){
		//キャラ発見時
		if(lp->found_flg == 1){
			lp->muki = GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16);	//常にプレーヤーを捕捉
			//射撃
			if(lp->wait <= 0){
				if(!(random()%5)){lp->wait = ((random()%6)+3)*FPS;}	//5発に1発の確立で次弾発射までのウェイトを設定(つまり、1~5+α程度の連射を行う)
				lp->flg = 2;	//[射撃]状態
				lp->koma = 0;
				rx = PL_X-18 + random()%51;	//狙う位置を定める
				ry = PL_Y-18 + random()%51;	//	〃
				hitparam = HitWmapLine(wmap, lmap, lp->x+16, lp->y+20, rx, ry);	//壁にあたってないか判定
				if(hitparam.flg){rx=hitparam.x; ry=hitparam.y;}	//あたってたら着弾点を修正
				MakeBullet(rx, ry, TEAM_E);	//弾丸発射
			}else{lp->wait--;}
			//見失う判定（再発見あり）
			lp->found_time--;
			if(lp->found_time <= 0){
				hitparam = HitWmapLine(wmap, lmap,lp->x+16,lp->y+16,PL_X+16,PL_Y+16);
				if(hitparam.flg == 0 && HitRect(-32,-32,VIDEO_W+64,VIDEO_H+64, lp->x,lp->y,32,32)){	//間に壁がなく、距離も近ければ・・・
					lp->found_time = EN_FOUND_TIME * FPS;	//発見時間追加
				}else{	//もし、見失っていたら・・・
					lp->found_flg = 0;	//発見モード解除
				}
			}
		}
		//通常時
		else{
			//移動処理
			if(lp->move_flg){
				hitflg = 0;
				if(lp->muki==7 || lp->muki==0 || lp->muki==1){//上-------------
					lp->y-=1;
					//MAPとのあたり判定
					for(i=5; i<27; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+10);
						if(hitparam.flg){lp->y+=32-hitparam.y; hitflg=1; break;}
					}
				}
				if(lp->muki==3 || lp->muki==4 || lp->muki==5){//下---------------
					lp->y+=1;
					//MAPとのあたり判定
					for(i=5; i<27; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+31);
						if(hitparam.flg){lp->y-=hitparam.y+1; hitflg=1; break;}
					}
				}
				if(lp->muki==5 || lp->muki==6 || lp->muki==7){//左-------------
					lp->x-=1;
					//MAPとのあたり判定
					for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+5, lp->y+i);
						if(hitparam.flg){lp->x+=32-hitparam.x; hitflg=1; break;}
					}
				}
				if(lp->muki==1 || lp->muki==2 || lp->muki==3){//右-------------
					lp->x+=1;
					//MAPとのあたり判定
					for(i=10; i<32; i++){
						hitparam = HitWmap(wmap, lmap, lp->x+26, lp->y+i);	
						if(hitparam.flg){lp->x-=hitparam.x+1; hitflg=1; break;}
					}
				}
				//壁にあたったら方向転換
				if(hitflg){lp->muki = random()%8;}
				lp->koma = (lp->koma+1)%40;
			}
			//プレーヤー周辺なら行動
			if(HitRect(0,0,VIDEO_W,VIDEO_H, lp->x,lp->y,32,32)){
				//索敵処理
				if(lp->muki == GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16)){	//向いてる方向にキャラがいて・・・
					hitparam = HitWmapLine(wmap, lmap,lp->x+16,lp->y+16,PL_X+16,PL_Y+16);
					if(hitparam.flg == 0){	//間に壁がなければ・・・
						lp->found_flg = 1;	//発見!!!!
						lp->found_time = EN_FOUND_TIME * FPS;
					}
				}
			}
			lp->move_flg = (lp->move_flg+1)%2;	//フレーム飛ばしに移動処理を行い、速度を緩める
		}
	}
	//射撃--------------------------------------
	else if(lp->flg == 2){
		lp->koma++;	//アニメのコマを進めるだけの処理
		if(lp->koma >= 12){lp->flg = 1;}	//[射撃]状態解除
	}

}
//敵制御C	ボムタイプ
void MoveEnemyTypeC(WMAP wmap, LMAP lmap, ENEMY *lp){

	//壁越しでもなんでも、とにかくキャラが一定距離に入ったらボム投擲！！！！
	if(lp->flg == 1){
		//プレーヤー周辺なら行動
		if(HitRect(0,0,VIDEO_W,VIDEO_H, lp->x,lp->y,32,32)){
			if(GetRange(lp->x+16,lp->y+16,PL_X+16,PL_Y+16) <= EN_BOM_FOUND_RANGE){
				lp->muki = GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16);	//常にプレーヤーを捕捉
				if(lp->wait <= 0){
					lp->wait = ((random()%6)+5)*FPS;	//次弾発射までのウェイト設定
					MakeBom(lp->x+16,lp->y+16,PL_X+16,PL_Y+16);	//ボム投擲
				}else{lp->wait--;}
			}
		}
	}
}
//敵制御D	足止めタイプ（移動しかしない）
void MoveEnemyTypeD(WMAP wmap, LMAP lmap, ENEMY *lp){
	int i;
	unsigned char hitflg;	//何かしら壁にあたったらON
	HITPARAM hitparam;

	//通常--------------------------------------
	if(lp->flg == 1){
		//キャラ発見時
		if(lp->found_flg == 1){
			lp->muki = GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16);	//常にプレーヤーを捕捉
			//プレーヤーに向かってダッシュ
			//移動処理
			hitflg = 0;
			if(lp->muki==7 || lp->muki==0 || lp->muki==1){//上-------------
				lp->y-=2;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+10);
					if(hitparam.flg){lp->y+=32-hitparam.y; hitflg=1; break;}
				}
			}
			if(lp->muki==3 || lp->muki==4 || lp->muki==5){//下---------------
				lp->y+=2;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+31);
					if(hitparam.flg){lp->y-=hitparam.y+1; hitflg=1; break;}
				}
			}
			if(lp->muki==5 || lp->muki==6 || lp->muki==7){//左-------------
				lp->x-=2;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+5, lp->y+i);
					if(hitparam.flg){lp->x+=32-hitparam.x; hitflg=1; break;}
				}
			}
			if(lp->muki==1 || lp->muki==2 || lp->muki==3){//右-------------
				lp->x+=2;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+26, lp->y+i);
					if(hitparam.flg){lp->x-=hitparam.x+1; hitflg=1; break;}
				}
			}
			lp->koma = (lp->koma+1)%40;
			//見失う判定（再発見あり）
			lp->found_time--;
			if(lp->found_time <= 0){
				hitparam = HitWmapLine(wmap, lmap,lp->x+16,lp->y+16,PL_X+16,PL_Y+16);
				if(hitparam.flg == 0){	//間に壁がなければ・・・
					lp->found_time = EN_FOUND_TIME * FPS;	//発見時間追加
				}else{	//もし、見失っていたら・・・
					lp->found_flg = 0;	//発見モード解除
				}
			}
		}
		//通常時
		else{
			//移動処理
			hitflg = 0;
			if(lp->muki==7 || lp->muki==0 || lp->muki==1){//上-------------
				lp->y-=2;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+10);
					if(hitparam.flg){lp->y+=32-hitparam.y; hitflg=1; break;}
				}
			}
			if(lp->muki==3 || lp->muki==4 || lp->muki==5){//下---------------
				lp->y+=2;
				//MAPとのあたり判定
				for(i=5; i<27; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+i, lp->y+31);
					if(hitparam.flg){lp->y-=hitparam.y+1; hitflg=1; break;}
				}
			}
			if(lp->muki==5 || lp->muki==6 || lp->muki==7){//左-------------
				lp->x-=2;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+5, lp->y+i);
					if(hitparam.flg){lp->x+=32-hitparam.x; hitflg=1; break;}
				}
			}
			if(lp->muki==1 || lp->muki==2 || lp->muki==3){//右-------------
				lp->x+=2;
				//MAPとのあたり判定
				for(i=10; i<32; i++){
					hitparam = HitWmap(wmap, lmap, lp->x+26, lp->y+i);
					if(hitparam.flg){lp->x-=hitparam.x+1; hitflg=1; break;}
				}
			}
			//壁にあたったら方向転換
			if(hitflg){lp->muki = random()%8;}
			lp->koma = (lp->koma+1)%40;
			//プレーヤー周辺なら行動
			if(HitRect(0,0,VIDEO_W,VIDEO_H, lp->x,lp->y,32,32)){
				//索敵処理
				if(lp->muki == GetMuki(lp->x+16,lp->y+16,PL_X+16,PL_Y+16)){	//向いてる方向にキャラがいて・・・
					hitparam = HitWmapLine(wmap, lmap,lp->x+16,lp->y+16,PL_X+16,PL_Y+16);
					if(hitparam.flg == 0){	//間に壁がなければ・・・
						lp->found_flg = 1;	//発見!!!!
						lp->found_time = EN_FOUND_TIME * FPS;
					}
				}
			}
		}
	}
}
//敵描画
void DrawEnemy(SDL_Surface *screen, SDL_Surface *img){
	ENEMY *lp;

	for(lp=enemy_head.next; lp!=NULL; lp=lp->next){
		//存在していたら
		if(lp->flg!=0){
			//画面内なら
			if(HitRect(0,0,VIDEO_W,VIDEO_H, lp->x,lp->y,32,32)){
				//通常
				if(lp->flg == 1){
					DrawBmp(screen, lp->x, lp->y, 32, 32, img,
					(lp->muki % 2) * 128 + (lp->koma / 10) * 32, 256 + (lp->muki /2) * 32, 32, 32);
				}
				//射撃
				else if(lp->flg == 2){
					DrawBmp(screen, lp->x, lp->y, 32, 32, img,
					(lp->muki % 2) * 128 + (lp->koma / 3) * 32, 384 + (lp->muki /2) * 32, 32, 32);
				}
				//ダメージ（ふっ飛び）
				else if(lp->flg == 3){
					DrawBmp(screen, lp->x, lp->y, 32, 32, img,
					(lp->muki % 2) * 128, 256 + (lp->muki /2) * 32, 32, 32);
				}
				//爆発
				else if(lp->flg == 4){
					DrawBmp(screen, lp->x, lp->y, 32, 32, img,
					128 + (lp->koma/4) * 32, 576, 32, 32);
				}
			}
		}
	}
}
//敵削除
int DeleteEnemy(void){
	ENEMY *lp, *lpSave;
	int delnum=0;

	lp = enemy_head.next;
	lpSave = &enemy_head;
	while(lp!=NULL){
		if(!lp->flg){
			lpSave->next = lp->next;
			free(lp);
			lp = lpSave->next;
			delnum++;
			continue;
		}
		lpSave = lp;
		lp = lp->next;
	}
	return delnum;
}
//敵全消去
void AllDelEnemy(void){
	ENEMY *lp, *lpSave;

	lp = enemy_head.next;
	while(lp!=NULL){
		lpSave = lp->next;
		free(lp);
		lp = lpSave;
	}
	enemy_head.next = NULL;
}
//自機と敵のあたり
void HitEnemy(PLAYER *player){
	ENEMY *lp;

	for(lp=enemy_head.next; lp!=NULL; lp=lp->next){
		if(lp->type == 3){	//足止めタイプなら
			if(HitRect(PL_X+9,PL_Y+4,15,27, lp->x+9,lp->y+4,15,27)){
				player->stop_flg = 1;
				return;
			}
		}
	}
	player->stop_flg = 0;
}
