#ifndef _ENEMY_H
#define _ENEMY_H

#include<SDL/SDL.h>
#include"main.h"
#include"map.h"
#include"chara.h"
#include"weapon.h"
#include"support.h"


#define EN_HP	40
#define EN_FOUND_TIME 10	//キャラを見失っても通常状態に戻らない時間
#define EN_BOM_FOUND_RANGE	120	//ボムタイプがプレーヤーを発見する距離
#define EN_POINT	30;	//倒したときの基本ポイント

typedef struct ENEMY{
	int x;			//x座標
	int y;			//y座標
	int hp;			//体力
	unsigned char muki;	//向き(上から時計回り 0~7)
	unsigned char koma;	//アニメのコマ
	unsigned char flg;	//状態フラグ(0:消去 1:通常 2:射撃 3:ダメージ 4:爆発)
	unsigned char move_flg;	//移動処理を行うかのフラグ
	int wait;			//待ち時間
	unsigned char found_flg;//発見フラグ(0:通常 1:発見)
	int found_time;		//発見状態から通常状態に戻る時間
	int tobi_wait;		//ふっ飛び待ち時間
	unsigned char tobi_muki;//ふっ飛ぶ向き(向きと〃様な内容)
	unsigned char type;	//キャラクタの性格(0:単発 1:連射 2:ボム)
	struct ENEMY *next;
}ENEMY;


void MakeEnemy(int x, int y, unsigned char type);		//敵作成
void MoveEnemy(WMAP wmap, LMAP lmap, int mx, int my, unsigned char flg);	//敵制御
void MoveEnemyTypeA(WMAP wmap, LMAP lmap, ENEMY *lp);					//敵制御A
void MoveEnemyTypeB(WMAP wmap, LMAP lmap, ENEMY *lp);					//敵制御B
void MoveEnemyTypeC(WMAP wmap, LMAP lmap, ENEMY *lp);					//敵制御C
void MoveEnemyTypeD(WMAP wmap, LMAP lmap, ENEMY *lp);					//敵制御D
void DrawEnemy(SDL_Surface *screen, SDL_Surface *img);	//敵描画
int DeleteEnemy(void);							//敵削除
void AllDelEnemy(void);							//敵全消去
void HitEnemy(PLAYER *player);		//自機と敵のあたり

#endif
