#include"game.h"

#define DEBUG

//グローバル変数
SOUNDPAC soundpac;	//サウンドパック

//タイトル
void Title(SDL_Surface *screen){
	SDL_Event event;
	unsigned char flg = 0;
	int rgb;
	SDL_PixelFormat *fmt;
	MOUSE_PARAM mouse_param = {0,0,0x00};	//マウス情報
	unsigned char cursor_flg = 0;	//カーソルがメニューに乗ってるか

	SDL_Surface *img;

	//画像読み込み
	img = (SDL_Surface *)IMG_Load("data/picture/title.bmp");
	if(img == NULL)printf("NOT READ FILE\n");
	SDL_SetColorKey(img, SDL_SRCCOLORKEY, 0x00000000);


	//メインループ===========================================
	while(flg == 0){
		//イベントループ
		while(SDL_PollEvent(&event)){
			switch(event.type){
				case SDL_MOUSEMOTION:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					if( HitRect(mouse_param.x,mouse_param.y,0,0, 124,150,70,18) ||
						HitRect(mouse_param.x,mouse_param.y,0,0, 107,180,106,18) ||
						HitRect(mouse_param.x,mouse_param.y,0,0, 134,210,51,18) ){
							if(!cursor_flg){
								cursor_flg = 1;
								PlaySound(&soundpac.select);	//選択音
							}
					}else{cursor_flg = 0;}
					break;
				case SDL_MOUSEBUTTONDOWN:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					switch(event.button.button){
						case SDL_BUTTON_LEFT:
							//START
							if(HitRect(mouse_param.x,mouse_param.y,0,0, 124,150,70,18)){
								PlaySound(&soundpac.start);	//決定音
								BlackOut(screen);
								GameMain(screen);
							}
							//RANKING
							if(HitRect(mouse_param.x,mouse_param.y,0,0, 107,180,106,18)){
								PlaySound(&soundpac.start);	//決定音
								RankingMain(screen);
							}
							//EXIT
							if(HitRect(mouse_param.x,mouse_param.y,0,0, 134,210,51,18)){
								PlaySound(&soundpac.start);	//決定音
								BlackOut(screen);
								flg = 1;
							}
							break;
					}
					break;
				case SDL_QUIT:
					flg = 1;
					break;
			}
		}

		//描画----------------------------------------------------------------------
//		fmt = screen->format;				//--------
//		rgb = SDL_MapRGB(fmt, 0x00, 0x00, 0x00);	//画面クリア
//		SDL_FillRect(screen, NULL, rgb);		//--------

		if(!flg){
			DrawBmp(screen, 0, 0, 320, 240, img, 0, 0, 320, 240);	//背景
			if(HitRect(mouse_param.x,mouse_param.y,0,0, 124,150,70,18)){
				DrawBmp(screen, 124, 150, 70, 18, img, 0, 258, 70, 18);
			}else{DrawBmp(screen, 124, 150, 70, 18, img, 0, 240, 70, 18);}	//START
			if(HitRect(mouse_param.x,mouse_param.y,0,0, 107,180,106,18)){
				DrawBmp(screen, 107, 180, 106, 18, img, 70, 258, 106, 18);
			}else{DrawBmp(screen, 107, 180, 106, 18, img, 70, 240, 106, 18);}	//RANKING
			if(HitRect(mouse_param.x,mouse_param.y,0,0, 134,210,51,18)){
				DrawBmp(screen, 134, 210, 51, 18, img, 176, 258, 51, 18);
			}else{DrawBmp(screen, 134, 210, 51, 18, img, 176, 240, 51, 18);}	//EXIT


			SDL_Flip(screen);
		}

		fps_wait(FPS);
	}
	//後始末===============================================
	SDL_FreeSurface(img);
	
}

//ゲームメイン
int GameMain(SDL_Surface *screen){
	SDL_Event event;
	unsigned char flg = 0;
	KEY_FLG key_flg=0x00;	//キーフラグ
	MOUSE_PARAM mouse_param = {0,0,0x00};	//マウス情報
	int rgb;
	SDL_PixelFormat *fmt;

	SDL_Surface *img1, *img2;	//画像

	WMAP wmap_data[MAP_NUM], wmap;	//ワールドマップ
	LMAP lmap;	//ローカルマップ
	LADDER ladder;	//梯子
	PLAYER player = {100,0,0,0,120,6,1,0,0,0,0};	//プレーヤー
	PL_MOVE pl_move;		//プレーヤー移動量
	int floor=1;	//フロア

	int i;

	//画像読み込み
	img1 = (SDL_Surface *)IMG_Load("data/picture/SHOT2.BMP");
	if(img1 == NULL)printf("NOT READ FILE\n");
	SDL_SetColorKey(img1, SDL_SRCCOLORKEY, 0x00000000);
	img2 = (SDL_Surface *)IMG_Load("data/picture/object.bmp");
	if(img2 == NULL)printf("NOT READ FILE\n");
	SDL_SetColorKey(img2, SDL_SRCCOLORKEY, 0x00000000);

	//ワールドマップまとめて読み込み
	if(WmapDataLoad(wmap_data) == -1)return -1;
	//ステージセッティング
	SetStage(wmap_data, &wmap, &lmap, &ladder, floor);


	//マウスカーソルを隠す
	SDL_ShowCursor(0);

	//BGM再生
	PlayBgm("data/bgm/bgm.wav");

	//メインループ===========================================
	while(flg == 0){
		//イベントループ
		while(SDL_PollEvent(&event)){
			switch(event.type){
				case SDL_KEYDOWN:
					switch(event.key.keysym.sym){
						case SDLK_w: key_flg |= KFLG_D_w; break;
						case SDLK_s: key_flg |= KFLG_D_s; break;
						case SDLK_a: key_flg |= KFLG_D_a; break;
						case SDLK_d: key_flg |= KFLG_D_d; break;
						case SDLK_q: player.hp--; break;
						case ESC_KEY: flg = 2; break;
#ifdef DEBUG
						case SDLK_p: MakeEnemy(mouse_param.x, mouse_param.y, random()%4); break;
						case SDLK_o: MakeItemBox(mouse_param.x, mouse_param.y); break;
#endif
					}
					break;
				case SDL_KEYUP:
					switch(event.key.keysym.sym){
						case SDLK_w: key_flg &= KFLG_U_w; break;
						case SDLK_s: key_flg &= KFLG_U_s; break;
						case SDLK_a: key_flg &= KFLG_U_a; break;
						case SDLK_d: key_flg &= KFLG_U_d; break;
					}
					break;
				case SDL_MOUSEMOTION:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					break;
				case SDL_MOUSEBUTTONDOWN:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					switch(event.button.button){
						case SDL_BUTTON_LEFT: mouse_param.bt |= MBT_D_LEFT; break;
						case SDL_BUTTON_RIGHT: mouse_param.bt |= MBT_D_RIGHT; break;
					}
					break;
				case SDL_MOUSEBUTTONUP:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					switch(event.button.button){
						case SDL_BUTTON_LEFT: mouse_param.bt &= MBT_U_LEFT; break;
						case SDL_BUTTON_RIGHT: mouse_param.bt &= MBT_U_RIGHT; break;
					}
					break;
				case SDL_QUIT:
					flg = 2;	//ランクイン無しで進む
					break;
			}
		}

		//制御----------------------------------------------------------------------
		MoveCursor(&player, lmap, mouse_param);	//キャラ　マウス操作
		pl_move = MovePlayer(&player, &lmap, wmap, key_flg);	//キャラ　キー操作

		MoveEnemy(wmap, lmap, pl_move.x, pl_move.y, pl_move.flg);	//敵

		MoveBom(pl_move.x, pl_move.y, pl_move.flg);	//ボム
		MoveBullet(pl_move.x, pl_move.y, pl_move.flg);	//弾丸
		MoveItemBox(pl_move.x, pl_move.y, pl_move.flg);	//アイテムボックス
		MoveItem(pl_move.x, pl_move.y, pl_move.flg);	//アイテム
		MoveLadder(&ladder, pl_move.x, pl_move.y, pl_move.flg);	//梯子

		//あたり判定------------------------------------------------------------------
		HitItem(&player);	//アイテム＆プレーヤー
		HitBullet(&player);	//弾丸＆ALL
		HitBom(&player);		//ボム＆ALL
		HitEnemy(&player);	//敵＆プレーヤー
		if(HitLadder(player, ladder)){	//梯子到達判定
			//ブラックアウトする
			BlackOut(screen);
			//フロアを１あげる
			floor++;
			//全てのオブジェクトを解放しておく
			AllDelEnemy();	//敵
			AllDelBom();	//ボム
			AllDelBullet();	//弾丸
			AllDelItemBox();	//アイテムボックス
			AllDelItem();	//アイテム
			DeleteWmap(&wmap);	//マップデータ解放
			//ステージをセットしなおす
			SetStage(wmap_data, &wmap, &lmap, &ladder, floor);	//ステージセッティング
		}
		if(player.flg == 0){flg = 1;}		//キャラ死亡判定

		//不用物の消去
		DeleteEnemy();	//敵
		DeleteBom();	//ボム
		DeleteBullet();	//弾丸
		DeleteItemBox();	//アイテムボックス
		DeleteItem();	//アイテム

		//描画----------------------------------------------------------------------
		fmt = screen->format;				//--------
		rgb = SDL_MapRGB(fmt, 0x00, 0x00, 0x00);	//画面クリア
		SDL_FillRect(screen, NULL, rgb);		//--------

		DrawLmap(screen, img1, lmap);			//マップ
		DrawLadder(screen, img2, ladder);		//梯子

		DrawItem(screen, img2);		//アイテム
		DrawItemBox(screen, img2);	//アイテムボックス

		DrawBom(screen, img1);		//ボム

		DrawEnemy(screen, img1);	//敵

		DrawPlayer(screen, img1, player);		//自機

		DrawBullet(screen, img1);	//弾丸

		DrawCursor(screen, img1, player, mouse_param);	//カーソル

		DrawWepSelect(screen, img2, player);	//武器変更時表示
		DrawState(screen, img2, player, floor);	//ステータス
		DrawToLadder(screen, img2, ladder);		//梯子方向

		SDL_Flip(screen);

		fps_wait(FPS);
//		fps_no();
	}
	//終了表示
	DrawBmp(screen, 107, 100, 106, 24, img2, 0, 150, 106, 24);
	if(flg == 1){
		if(RankIn(floor, player.score)){	//ランクイン処理＆判定
			DrawBmp(screen, 132, 130, 56, 12, img2, 0, 175, 56, 12);
		}
	}
	SDL_Flip(screen);
	for(i=0; i<FPS*5; i++){fps_wait(FPS);}
	BlackOut(screen);	//ブラックアウトする

	//後始末===============================================
	SDL_FreeSurface(img1);
	SDL_FreeSurface(img2);

	AllDelEnemy();	//敵
	AllDelBom();	//ボム
	AllDelBullet();	//弾丸
	AllDelItemBox();	//アイテムボックス
	AllDelItem();	//アイテム

	DeleteWmapData(wmap_data);	//マップデータをごっそり解放
	DeleteWmap(&wmap);	//マップデータ解放

	//マウスカーソルを表示
	SDL_ShowCursor(1);

	//BGM停止
	StopBgm();


	return 0;
}
//ステージのセッティング
void SetStage(WMAP wmap_data[], WMAP *wmap, LMAP *lmap, LADDER *ladder, unsigned floor){
	int px, py;
	int lx, ly;
	int itembox_num;
	int en_num;

	//マップのセッティング
	SetWmapRotation(wmap, wmap_data[random()%MAP_NUM], random()%4);	//データからランダムで
	//スタート位置決定(ローカルマップの初期位置の決定)
	do{px=random()%wmap->w; py=random()%wmap->h;}while(*(wmap->data + px + wmap->w*py));	//壁じゃない場所をランダム検索
	lmap->w_x = px - LMAP_W/2;
	lmap->w_y = py - LMAP_H/2;
	lmap->x = LMAP_DEF_X;
	lmap->y = LMAP_DEF_Y;
	SetLmap(lmap, *wmap);	//設定したらセットしましょう
	//梯子の設置
	do{lx=random()%wmap->w; ly=random()%wmap->h;}while(*(wmap->data + lx + wmap->w*ly) || px==lx&&py==ly);	//壁じゃない場所&&プレーヤーのいない場所をランダム検索
	ladder->x = (lx - lmap->w_x)*32 + lmap->x;
	ladder->y = (ly - lmap->w_y)*32 + lmap->y;
	//アイテムボックスの設置
	if(!(floor%5)){	//５の倍数のフロアだけ出現
		itembox_num = (random()%ITEMBOX_NUM)+1;
		while(itembox_num > 0){
			do{px=random()%wmap->w; py=random()%wmap->h;}while(*(wmap->data + px + wmap->w*py) || px==lx&&py==ly);	//壁じゃない場所&&梯子のない場所をランダム検索	
			MakeItemBox((px - lmap->w_x)*32 + lmap->x, (py - lmap->w_y)*32 + lmap->y);
			itembox_num--;
		}
	}
	//敵の配置
	for(en_num=0; en_num<DEF_EN_NUM+floor*3; en_num++){
		do{px=random()%wmap->w; py=random()%wmap->h;}while(*(wmap->data + px + wmap->w*py));	//壁じゃない場所をランダム検索
		MakeEnemy((px - lmap->w_x)*32 + lmap->x, (py - lmap->w_y)*32 + lmap->y, random()%4);
	}
	
}


//ランキング===============================================================================
//ランキング画面
void RankingMain(SDL_Surface *screen){
	SDL_Event event;
	unsigned char flg = 0;
	int rgb;
	SDL_PixelFormat *fmt;
	MOUSE_PARAM mouse_param = {0,0,0x00};	//マウス情報

	SCORE_RANK score_rank[RANK_NUM];	//SCORE ランキングデータ
	FLOOR_RANK floor_rank[RANK_NUM];	//KLOOR ランキングデータ

	char rank_flg = 0;	//ランキング表示フラグ(0:スコア 1:フロア)

	SDL_Surface *img;

	TTF_Font *font;
	SDL_Color cl_white={0xff,0xff,0xff,0x00};
	SDL_Surface *txt_rank[5];
	SDL_Rect dsr;
	char buf[200];
	int i;

	unsigned char cursor_flg = 0;	//カーソルがメニューに乗ってるか

	//画像読み込み
	img = (SDL_Surface *)IMG_Load("data/picture/ranking.bmp");
	if(img == NULL)printf("NOT READ FILE\n");
	SDL_SetColorKey(img, SDL_SRCCOLORKEY, 0x00000000);

	//フォント設定
	TTF_Init();
	font = TTF_OpenFont("/usr/share/fonts/truetype/japanese/ipamp-mona.ttf", 16);

	//ランキング読み込み
	LoadRanking(score_rank, floor_rank);

	//ランキングセット
	for(i=0; i<RANK_NUM; i++){
		sprintf(buf, "%d    %3dF  %10ld", i+1, score_rank[i].floor, score_rank[i].score);
		txt_rank[i] = TTF_RenderUTF8_Solid(font, buf, cl_white);
	}

	//メインループ===========================================
	while(flg == 0){
		//イベントループ
		while(SDL_PollEvent(&event)){
			switch(event.type){
				case SDL_MOUSEMOTION:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					if(HitRect(mouse_param.x,mouse_param.y,0,0, 82,44,10,15) ||
						HitRect(mouse_param.x,mouse_param.y,0,0, 238,44,10,15) ||
						HitRect(mouse_param.x,mouse_param.y,0,0, 146,220,48,18) ){
							if(!cursor_flg){
								cursor_flg = 1;
								PlaySound(&soundpac.select);	//選択音
							}
					}else{cursor_flg = 0;}
					break;
				case SDL_MOUSEBUTTONDOWN:
					mouse_param.x = event.motion.x;
					mouse_param.y = event.motion.y;
					switch(event.button.button){
						case SDL_BUTTON_LEFT:
							if(HitRect(mouse_param.x,mouse_param.y,0,0, 82,44,10,15)){		//←
								PlaySound(&soundpac.start);	//決定音
								if(--rank_flg < 0){rank_flg = 1;}
								if(rank_flg == 0){
									for(i=0; i<RANK_NUM; i++){
										SDL_FreeSurface(txt_rank[i]);
										sprintf(buf, "%d    %3dF  %10ld", i+1, score_rank[i].floor, score_rank[i].score);
										txt_rank[i] = TTF_RenderUTF8_Solid(font, buf, cl_white);
									}
								}else if(rank_flg == 1){
									for(i=0; i<RANK_NUM; i++){
										SDL_FreeSurface(txt_rank[i]);
										sprintf(buf, "%d    %3dF  %10ld", i+1, floor_rank[i].floor, floor_rank[i].score);
										txt_rank[i] = TTF_RenderUTF8_Solid(font, buf, cl_white);
									}
								}
							}
							if(HitRect(mouse_param.x,mouse_param.y,0,0, 238,44,10,15)){		//→
								PlaySound(&soundpac.start);	//決定音
								rank_flg = (rank_flg+1)%2;
								if(rank_flg == 0){
									for(i=0; i<RANK_NUM; i++){
										SDL_FreeSurface(txt_rank[i]);
										sprintf(buf, "%d    %3dF  %10ld", i+1, score_rank[i].floor, score_rank[i].score);
										txt_rank[i] = TTF_RenderUTF8_Solid(font, buf, cl_white);
									}
								}else if(rank_flg == 1){
									for(i=0; i<RANK_NUM; i++){
										SDL_FreeSurface(txt_rank[i]);
										sprintf(buf, "%d    %3dF  %10ld", i+1, floor_rank[i].floor, floor_rank[i].score);
										txt_rank[i] = TTF_RenderUTF8_Solid(font, buf, cl_white);
									}
								}
							}
							if(HitRect(mouse_param.x,mouse_param.y,0,0, 146,220,48,18)){	//EXIT
								PlaySound(&soundpac.start);	//決定音
								flg = 1;
							}
							break;
					}
					break;
				case SDL_QUIT:
					flg = 1;
					break;
			}
		}

		//描画----------------------------------------------------------------------
		fmt = screen->format;				//--------
		rgb = SDL_MapRGB(fmt, 0x00, 0x00, 0x00);	//画面クリア
		SDL_FillRect(screen, NULL, rgb);		//--------

		DrawBmp(screen, 90, 6, 140, 24, img, 0, 0, 140, 24);	//RANKING
		DrawBmp(screen, 102, 40, 116, 20, img, 0, 24+20*rank_flg, 116, 20);	//種類表示(SCORE FLOOR)
		for(i=0; i<RANK_NUM; i++){
			dsr.x = 80;
			dsr.y = 80 + 25*i;
			SDL_BlitSurface(txt_rank[i], NULL, screen, &dsr);		//ランキング内容表示
		}
		if(HitRect(mouse_param.x,mouse_param.y,0,0, 82,44,10,15)){
			DrawBmp(screen, 82, 44, 10, 15, img, 116, 39, 10, 15);
		}else{DrawBmp(screen, 82, 44, 10, 15, img, 116, 24, 10, 15);}	//←
		if(HitRect(mouse_param.x,mouse_param.y,0,0, 238,44,10,15)){
			DrawBmp(screen, 238, 44, 10, 15, img, 126, 39, 10, 15);
		}else{DrawBmp(screen, 238, 44, 10, 15, img, 126, 24, 10, 15);}	//→
		if(HitRect(mouse_param.x,mouse_param.y,0,0, 146,220,48,18)){
			DrawBmp(screen, 136, 220, 48, 18, img, 48, 84, 48, 18);
		}else{DrawBmp(screen, 136, 220, 48, 18, img, 0, 84, 48, 18);}	//EXIT


		SDL_Flip(screen);

		fps_wait(FPS);
	}
	//後始末===============================================
	SDL_FreeSurface(img);
	for(i=0; i<RANK_NUM; i++){SDL_FreeSurface(txt_rank[i]);}

}
//ランキングロード
void LoadRanking(SCORE_RANK s_rank[], FLOOR_RANK f_rank[]){
	FILE *fp;
	int i;
	int f_buf;
	long s_buf;

	//スコアランキング読み込み
	if((fp = fopen("data/ranking/score_ranking.dat","r")) == NULL){
		for(i=0; i<RANK_NUM; i++){s_rank[i].floor=0; s_rank[i].score=0;}
	}else{
		i=0;
		while(fscanf(fp, "%d %ld",&f_buf,&s_buf)!=EOF && i<RANK_NUM){
			s_rank[i].floor = f_buf;
			s_rank[i].score = s_buf;
			i++;
		}
		fclose(fp);
	}

	//フロアランキング読み込み
	if((fp = fopen("data/ranking/floor_ranking.dat","r")) == NULL){
		for(i=0; i<RANK_NUM; i++){f_rank[i].floor=0; f_rank[i].score=0;}
	}else{
		i=0;
		while(fscanf(fp, "%d %ld",&f_buf,&s_buf)!=EOF && i<RANK_NUM){
			f_rank[i].floor = f_buf;
			f_rank[i].score = s_buf;
			i++;
		}
		fclose(fp);
	}

}
//ランクイン処理
int RankIn(int f, long score){
	SCORE_RANK s_rank[RANK_NUM];
	FLOOR_RANK f_rank[RANK_NUM];
	int i,j;
	int ret=0;

	//ランキング読み込み
	LoadRanking(s_rank,f_rank);

	//スコアランキングランクイン処理
	for(i=0; i<RANK_NUM; i++){
		if(score > s_rank[i].score){
			ret=1;
			for(j=RANK_NUM-1; j>i; j--){
				s_rank[j] = s_rank[j-1];
			}
			s_rank[i].floor = f;
			s_rank[i].score = score;
			break;
		}
	}

	//フロアランキングランクイン処理
	for(i=0; i<RANK_NUM; i++){
		if(f > f_rank[i].floor){
			ret=1;
			for(j=RANK_NUM-1; j>i; j--){
				f_rank[j] = f_rank[j-1];
			}
			f_rank[i].floor = f;
			f_rank[i].score = score;
			break;
		}
	}

	if(ret)SaveRanking(s_rank, f_rank);

	return ret;
}
//ランキングセーブ
void SaveRanking(SCORE_RANK s_rank[], FLOOR_RANK f_rank[]){
	FILE *fp;
	int i;

	if((fp = fopen("data/ranking/score_ranking.dat","w")) == NULL){
		printf("スコアランキングファイル　オープンエラー\n");
		exit(0);
	}
	for(i=0; i<RANK_NUM; i++){
		fprintf(fp, "%d %ld\n",s_rank[i].floor,s_rank[i].score);
	}
	fclose(fp);

	if((fp = fopen("data/ranking/floor_ranking.dat","w")) == NULL){
		printf("フロアランキングファイル　オープンエラー\n");
		exit(0);
	}
	for(i=0; i<RANK_NUM; i++){
		fprintf(fp, "%d %ld\n",f_rank[i].floor,f_rank[i].score);
	}
	fclose(fp);

}
