#include"main.h"
#include"game.h"
#include"audio.h"

SOUNDPAC soundpac;

int main(int argc, char *argv[]){
	SDL_Surface *screen;
	SDL_Rect src, dsr;	//画像描画用座標構造体

	//初期化==============================================
	//ビデオシステム初期化
	if(SDL_Init(SDL_INIT_VIDEO) < 0){
		return -1;
	}
	//オーディオ初期化
	if(SDL_InitSubSystem(SDL_INIT_AUDIO) < 0){
		return -1;
	}
	if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, 2, 1024) < 0){
		return -1;
	}
	//タイトルバー関連
	SDL_WM_SetIcon(SDL_LoadBMP("data/picture/ICON.BMP"), NULL);
	SDL_WM_SetCaption("ROBO MAZE", NULL);
	//windowのビデオモード設定
	screen = SDL_SetVideoMode(VIDEO_W, VIDEO_H, VIDEO_BIT, SDL_SWSURFACE/*|SDL_FULLSCREEN*/);
	if(screen == NULL){
		return -1;
	}
	
	srandom(time(0));

	//サウンド読み込み
	LoadSoundPac(&soundpac);

	//メイン
	Title(screen);


	//後始末===============================================
	//サウンド解放
	FreeSoundPac(&soundpac);

	SDL_FreeSurface(screen);
	Mix_CloseAudio();

	printf("OFF\n");
	SDL_Quit();
	return 0;
}
