#include"object.h"

ITEMBOX itembox_head;
ITEM item_head;

SOUNDPAC soundpac;	//サウンドパック


//梯子==============================================================================
//梯子移動
void MoveLadder(LADDER *ladder, int mx, int my, unsigned char flg){
	if(flg){ladder->x-=mx; ladder->y-=my;}
}
//梯子描画
void DrawLadder(SDL_Surface *screen, SDL_Surface *img, LADDER ladder){
	int deg;
	if(HitRect(0, 0, VIDEO_W, VIDEO_H, ladder.x, ladder.y, 32, 32)){	//梯子を描画
		DrawBmp(screen, ladder.x, ladder.y, 32, 32, img, 32, 75, 32, 32);
	}
}
//梯子方向描画
void DrawToLadder(SDL_Surface *screen, SDL_Surface *img, LADDER ladder){
	int deg;
	if(!HitRect(0, 0, VIDEO_W, VIDEO_H, ladder.x, ladder.y, 32, 32)){	//梯子のおおまかな位置を描画
		deg = GetDeg(PL_X+16,PL_Y+16,ladder.x,ladder.y);
		deg = (deg + 45) % 360;
		deg = deg / 90;
		DrawBmp(screen, 260, 3, 16, 16, img, 32+16*deg, 40, 16, 16);
	}
}
//梯子＆プレーヤーあたり
int HitLadder(PLAYER player, LADDER ladder){
	if(HitRect(PL_X+7, PL_Y+14, 18, 18, ladder.x+8, ladder.y+10, 16, 12))return 1;
	return 0;
}

//アイテムボックス====================================================================
//アイテムボックス作成
void MakeItemBox(int x, int y){
	ITEMBOX *lpNew, *lp;

	if(( lpNew = (ITEMBOX *)malloc(sizeof(ITEMBOX)) ) == NULL){
		printf("アイテムボックス作成・・・メモリ乙\n");
		exit(0);
	}

	lpNew->x = x;
	lpNew->y = y;
	lpNew->anime = 0;
	lpNew->flg = 1;
	lpNew->next = NULL;

	lp = &itembox_head;
	while(lp->next != NULL){
		lp = lp->next;
	}

	lp->next = lpNew;

}
//アイテムボックス移動
void MoveItemBox(int mx, int my, unsigned char flg){
	ITEMBOX *lp;
	for(lp=itembox_head.next; lp!=NULL; lp=lp->next){
		if(flg){lp->x-=mx; lp->y-=my;}
		if(lp->flg == 2){
			lp->anime++;
			if(lp->anime >= 12){	//爆発終了
				lp->flg = 0;
				MakeItem(lp->x+8, lp->y+8, (unsigned char)(random()%2));	//アイテム出現
			}
		}
	}
}
//アイテムボックス描画
void DrawItemBox(SDL_Surface *screen, SDL_Surface *img){
	ITEMBOX *lp;
	for(lp=itembox_head.next; lp!=NULL; lp=lp->next){
		//通常時
		if(lp->flg == 1){
			if(HitRect(0,0,VIDEO_W,VIDEO_H,lp->x,lp->y,32,32)){
				DrawBmp(screen, lp->x, lp->y, 32, 32, img, 0, 75, 32, 32);
			}
		}
		//爆発時
		else if(lp->flg == 2){
				DrawBmp(screen, lp->x, lp->y, 32, 32, img, (lp->anime/4)*32, 107, 32, 32);
		}
	}
}
//アイテムボックス削除
void DeleteItemBox(void){
	ITEMBOX *lp, *lpSave;

	lp = itembox_head.next;
	lpSave = &itembox_head;
	while(lp!=NULL){
		if(!lp->flg){
			lpSave->next = lp->next;
			free(lp);
			lp = lpSave->next;
			continue;
		}
		lpSave = lp;
		lp = lp->next;
	}
}
//アイテムボックス全消去
void AllDelItemBox(void){
	ITEMBOX *lp, *lpSave;

	lp = itembox_head.next;
	while(lp!=NULL){
		lpSave = lp->next;
		free(lp);
		lp = lpSave;
	}
	itembox_head.next = NULL;
}

//アイテム===========================================================================
//アイテム作成
void MakeItem(int x, int y, unsigned char type){
	ITEM *lpNew, *lp;

	if(( lpNew = (ITEM *)malloc(sizeof(ITEM)) ) == NULL){
		printf("アイテム作成・・・メモリ乙\n");
		exit(0);
	}

	lpNew->x = x;
	lpNew->y = y;
	lpNew->type = type;
	lpNew->time = ITEM_TIME * FPS;
	lpNew->flg = 1;
	lpNew->next = NULL;

	lp = &item_head;
	while(lp->next != NULL){
		lp = lp->next;
	}

	lp->next = lpNew;

}
//アイテム移動
void MoveItem(int mx, int my, const unsigned char flg){
	ITEM *lp;
	for(lp=item_head.next; lp!=NULL; lp=lp->next){
		if(flg){lp->x-=mx; lp->y-=my;}
		if(lp->flg == 1){
			lp->time--;
			if(lp->time < 0){lp->flg = 0;}
		}
	}
}
//アイテム描画
void DrawItem(SDL_Surface *screen, SDL_Surface *img){
	ITEM *lp;
	for(lp=item_head.next; lp!=NULL; lp=lp->next){
		//通常時
		if(lp->flg == 1){
			if(HitRect(0,0,VIDEO_W,VIDEO_H,lp->x,lp->y,16,16)){
				if(lp->time >= FPS*3 || (lp->time%20)>5){
					DrawBmp(screen, lp->x, lp->y, 16, 16, img, lp->type*16, 40, 16, 16);
				}
			}
		}
	}
}
//アイテム削除
void DeleteItem(void){
	ITEM *lp, *lpSave;

	lp = item_head.next;
	lpSave = &item_head;
	while(lp!=NULL){
		if(!lp->flg){
			lpSave->next = lp->next;
			free(lp);
			lp = lpSave->next;
			continue;
		}
		lpSave = lp;
		lp = lp->next;
	}
}
//アイテム全消去
void AllDelItem(void){
	ITEM *lp, *lpSave;

	lp = item_head.next;
	while(lp!=NULL){
		lpSave = lp->next;
		free(lp);
		lp = lpSave;
	}
	item_head.next = NULL;
}
//アイテム＆プレーヤーあたり
void HitItem(PLAYER *player){
	ITEM *lp;
	for(lp=item_head.next; lp!=NULL; lp=lp->next){
		if(lp->flg == 1){
			if(HitRect(PL_X+7,PL_Y+14,18,18,lp->x,lp->y,16,16)){
				PlaySound(&soundpac.item);	//サウンド
				if(lp->type == 0){
					player->mg_ammo += MG_AMMO_UP;
					player->bom_ammo += BOM_AMMO_UP;
					lp->flg = 0;
				}
				else if(lp->type == 1){
					player->hp += HP_UP;
					if(player->hp > 100){player->hp = 100;}
					lp->flg = 0;
				}
			}
		}
	}
}
