#ifndef _OBJECT_H
#define _OBJECT_H

#include<SDL/SDL.h>
#include"main.h"
#include"map.h"
#include"chara.h"
#include"support.h"
#include"audio.h"

#define ITEM_TIME	10.0	//アイテム持続時間（秒）
#define MG_AMMO_UP	40	//マシンガン弾の補給量
#define BOM_AMMO_UP	2	//ボムの補給量
#define HP_UP	50	//HP回復量


//梯子
typedef struct LADDER{
	int x;	//x座標
	int y;	//y座標
}LADDER;

//アイテムボックス
typedef struct ITEMBOX{
	int x;	//x座標
	int y;	//y座標
	unsigned char flg;	//状態フラグ（0:消去 1:通常 2:爆発）
	int anime;	//アニメ
	struct ITEMBOX *next;
}ITEMBOX;

//アイテム
typedef struct ITEM{
	int y;	//x座標
	int x;	//y座標
	unsigned char type;	//種類(0:AMMO缶 1:工具箱)
	int time;	//持続時間
	unsigned char flg;	//状態フラグ(0:消去 1:通常)
	struct ITEM *next;
}ITEM;


void MoveLadder(LADDER *ladder, int mx, int my, unsigned char flg);	//梯子移動
void DrawLadder(SDL_Surface *screen, SDL_Surface *img, LADDER ladder);	//梯子描画
void DrawToLadder(SDL_Surface *screen, SDL_Surface *img, LADDER ladder);//梯子方向描画
int HitLadder(PLAYER player, LADDER ladder);					//梯子＆プレーヤーあたり

void DrawToLadder(SDL_Surface *screen, SDL_Surface *image, LADDER ladder);	//梯子のある方向を表示する


void MakeItemBox(int x, int y);					//アイテムボックス作成
void MoveItemBox(int mx, int my, unsigned char flg);		//アイテムボックス移動
void DrawItemBox(SDL_Surface *screen, SDL_Surface *img);	//アイテムボックス描画
void DeleteItemBox(void);						//アイテムボックス削除
void AllDelItemBox(void);						//アイテムボックス全消去

void MakeItem(int x, int y, const unsigned char type);	//アイテム作成
void MoveItem(int mx, int my, unsigned char flg);	//アイテム移動
void DrawItem(SDL_Surface *screen, SDL_Surface *img);	//アイテム描画
void DeleteItem(void);						//アイテム削除
void AllDelItem(void);						//アイテム全消去
void HitItem(PLAYER *player);					//アイテム＆プレーヤーあたり

#endif
