#include"support.h"


// FPS ==========================================
//　ウェイト
//引数　ミリ秒
void wait( int wait_time ){
	//clock_t start, now;
	int start, now;

	start = SDL_GetTicks();//clock();
	now = SDL_GetTicks();//clock();
	while( wait_time > now - start ){
		SDL_Delay(1);
		now = SDL_GetTicks();//clock();
	}
}
//　FPSに対応するウェイト
//引数　目標FPS
void fps_wait( int fps ){
	//static clock_t m_start=0, m_now;
	static int m_start=0, m_now;

	m_now = SDL_GetTicks();//clock();
	wait( 1000/fps - (m_now - m_start) );
	//printf("wait %d\n",1000/fps - (m_now - m_start));
	m_start = SDL_GetTicks();//clock();
}
//　FPSの計算
//戻値　算出したFPS
float fps_chk( void ){
	static clock_t m_start=0, m_now;
	float fps = 0;

	m_now = clock();
	if( m_now - m_start > 0)
		fps = 1000.0 / ( m_now - m_start );
	m_start = clock();
	
	return fps;
}
//FPSのチェック
int fps_no(){
	static int tick = 0;
	static int cnt = 0, fps = 0;
	cnt++;
	if(tick+1000<SDL_GetTicks()){
		fps = cnt;
		cnt = 0;
		tick = SDL_GetTicks();
//		printf("%dFPS\n",fps);
		return fps;
	}
	return 0;
}


// 計算 ===================================================
//角度（ラジアン）計算
double GetRad(float x1, float y1, float x2, float y2){
	double rad;
	if(x1==x2&&y1==y2){return 0.0;}
	rad = atan2(y2-y1, x2-x1);
	if(rad<0.0){rad += 3.14159265358979*2.0;}
	return rad;
}
//角度計算
int GetDeg(float x1, float y1, float x2, float y2){
	int kaku;
	double rad;
	rad = GetRad(x1, y1, x2, y2);
	kaku = rad * 180.0/3.14159265358979;
	if(kaku<0){kaku += 360;}
	return kaku;
}
//距離計算
double GetRange(float x1, float y1, float x2, float y2){
	return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

// 判定 ===================================================
//□：□あたり判定
int HitRect(int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2){
	if(	x1+w1 > x2 &&
		x1 < x2+w2 &&
		y1+h1 > y2 &&
		y1 < y2+h2	){
			return 1;
	}
	return 0;
}
//○：○のあたり判定
int HitCircle(int x1, int y1, int r1, int x2, int y2, int r2){
	if((r1+r2)*(r1+r2) > (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))return 1;
	return 0;
}

// 描画 ===================================================
//ビットマップ描画
void DrawBmp(SDL_Surface *screen, int dx, int dy, int dw, int dh, SDL_Surface *img, int sx, int sy, int sw, int sh){
	SDL_Rect src, dsr;
	src.x = sx;
	src.y = sy;
	src.w = sw;
	src.h = sh;
	dsr.x = dx;
	dsr.y = dy;
	dsr.w = dw;
	dsr.h = dh;
	SDL_BlitSurface(img, &src, screen, &dsr);
}
//ブラックアウト
void BlackOut(SDL_Surface *screen){
	SDL_Rect dstrect;
	int x=0, y=0;
	unsigned char flg[8][10]={0};
	unsigned char endflg = 0;
	Uint32 black;
	SDL_Event event;


	for(y=0; y<8; y++){
		for(x=0; x<10; x++){flg[y][x]=0;}
	}
	black = SDL_MapRGB(screen->format, 0x00, 0x00, 0x00);
	while(endflg == 0){
		x = random()%10;
		y = random()%8;
		dstrect.x = x*32;
		dstrect.y = y*32;
		dstrect.w = 32;
		dstrect.h = 32;
		if(flg[y][x] == 0){
			flg[y][x]=1;
			SDL_FillRect(screen, &dstrect, black);
			SDL_Flip(screen);
			fps_wait(FPS);
		}
		endflg = 1;
		for(y=0; y<8; y++){
			for(x=0; x<10; x++){
				if(flg[y][x] == 0){endflg = 0; break;}
			}
		}
	}

}
