#include"weapon.h"


//グローバル変数
BULLET bullet_head;	//弾丸ヘッド
BOM bom_head;		//ボムヘッド

ITEMBOX itembox_head;	//アイテムボックスヘッド

ENEMY enemy_head;		//敵ヘッド

SOUNDPAC soundpac;	//サウンドパック


//弾丸==================================================================

//作成
//引数　x,y座標　チーム
void MakeBullet(int x, int y, unsigned char team){
	BULLET *lpNew, *lp;

	if(( lpNew = (BULLET *)malloc(sizeof(BULLET)) ) == NULL){
		printf("弾丸作成・・・メモリ乙\n");
		exit(0);
	}

	PlaySound(&soundpac.gun_shot);	//サウンド

	lpNew->x = x;
	lpNew->y = y;
	lpNew->anime = 0;
	lpNew->flg = 1;
	lpNew->team = team;
	lpNew->next = NULL;

	lp = &bullet_head;
	while(lp->next != NULL){
		lp = lp->next;
	}

	lp->next = lpNew;

}
//制御
//引数　プレーヤー移動量
void MoveBullet(int mx, int my, unsigned char flg){
	BULLET *lp;

	for(lp=bullet_head.next; lp!=NULL; lp=lp->next){
		//キャラ移動があった場合は座標更新
		if(flg){lp->x-=mx; lp->y-=my;}

		//ダメージあり
		if(lp->flg == 1){
			lp->anime++;
			if(lp->anime > 1){lp->flg = 2;}	//一定時間で[ダメージなし]に移行
		}
		//ダメージなし
		else if(lp->flg == 2){
			lp->anime++;
			if(lp->anime >= 8){lp->flg = 0;}	//一定時間で[消去]に移行
		}
	}

}
//描画
//引数　描画場所　使用画像
void DrawBullet(SDL_Surface *screen, SDL_Surface *img){
	BULLET *lp;

	for(lp=bullet_head.next; lp!=NULL; lp=lp->next){
		if(lp->flg){
			DrawBmp(screen, lp->x-16, lp->y-16, 32, 32, img, 32*(lp->anime/2), 544, 32, 32);
		}
	}

}
//消去
void DeleteBullet(void){
	BULLET *lp, *lpSave;

	lp = bullet_head.next;
	lpSave = &bullet_head;
	while(lp!=NULL){
		if(!lp->flg){
			lpSave->next = lp->next;
			free(lp);
			lp = lpSave->next;
			continue;
		}
		lpSave = lp;
		lp = lp->next;
	}

}
//全消去
void AllDelBullet(void){
	BULLET *lp, *lpSave;

	lp = bullet_head.next;
	while(lp!=NULL){
		lpSave = lp->next;
		free(lp);
		lp = lpSave;
	}
	bullet_head.next = NULL;

}
//弾丸＆ALLあたり
void HitBullet(PLAYER *player){
	BULLET *lp_bt;
	ITEMBOX *lp_ibox;
	ENEMY *lp_en;
	unsigned char hitflg;

	for(lp_bt=bullet_head.next; lp_bt!=NULL; lp_bt=lp_bt->next){
		hitflg = 0;
		//弾丸の状態が[ダメージ]なら
		if(lp_bt->flg == 1){
			//プレーヤー→・・・---------------------------
			if(lp_bt->team == TEAM_P){
				//→アイテムボックス
				for(lp_ibox=itembox_head.next; lp_ibox!=NULL; lp_ibox=lp_ibox->next){
					if(lp_ibox->flg == 1){
						if(HitRect(lp_bt->x, lp_bt->y, 0, 0, lp_ibox->x+3, lp_ibox->y+7, 27, 20)){
							PlaySound(&soundpac.dead);	//サウンド
							hitflg = 1;
							lp_bt->flg = 2;
							lp_ibox->flg = 2;
						}
					}
				}
				//→敵
				for(lp_en=enemy_head.next; lp_en!=NULL; lp_en=lp_en->next){
					if(lp_en->flg==1 || lp_en->flg==2){
						if(HitRect(lp_bt->x, lp_bt->y, 0, 0, lp_en->x+9, lp_en->y+4, 15, 27)){
							PlaySound(&soundpac.gun_damage);	//サウンド
							hitflg = 1;
							lp_bt->flg = 2;
							lp_en->found_flg = 1;	//発見!!!!(撃たれれば気づきますよw)
							lp_en->found_time = EN_FOUND_TIME * FPS;
							lp_en->hp -= BULLET_POWER;
							player->score += BULLET_POINT;	//スコア
							if(lp_en->hp <= 0){
								PlaySound(&soundpac.dead);	//サウンド
								lp_en->koma = 0;
								lp_en->flg = 4;
								player->score += EN_POINT;	//スコア
							}
						}
					}
				}
			}
			//敵→・・・----------------------------------
			else if(lp_bt->team == TEAM_E){
				//→プレーヤー
				if(player->flg==1 || player->flg==2){
					if(HitRect(lp_bt->x,lp_bt->y,0,0, PL_X+9,PL_Y+4,15,27)){
						PlaySound(&soundpac.gun_damage);	//サウンド
						hitflg = 1;
						lp_bt->flg = 2;
						player->hp -= BULLET_POWER;
						if(player->hp <= 0){
							PlaySound(&soundpac.dead);	//サウンド
							player->hp = 0;
							player->koma = 0;
							player->flg = 4;
						}
					}
				}
			}
			//外れ〜
			if(!hitflg){
				if(HitCircle(PL_X+16,PL_Y+16,50, lp_bt->x,lp_bt->y,1)){
					PlaySound(&soundpac.tyoudan[random()%3]);	//サウンド				
				}
				lp_bt->flg = 2;
			}
		}
	}
}

//ボム==========================================================
//作成
void MakeBom(int x, int y, int tx, int ty){
	BOM *lpNew, *lp;
	float a;	//ボム軌道の放物線の係数
	int i;

	if(( lpNew = (BOM *)malloc(sizeof(BOM)) ) == NULL){
		printf("ボム作成・・・メモリ乙\n");
		exit(0);
	}

	lpNew->x = x;
	lpNew->y = y;
	lpNew->range = GetRange(x, y, tx, ty);	//投擲距離
	lpNew->carry = 0.0;
	lpNew->rad = GetRad(x, y, tx, ty);	//角度(ラジアン)
	lpNew->time = BOM_DELAY * FPS;	//時間
	lpNew->anime = 0;
	lpNew->flg = 1;
	lpNew->next = NULL;

	lp = &bom_head;
	while(lp->next != NULL){
		lp = lp->next;
	}

	lp->next = lpNew;

}
//制御
void MoveBom(int mx, int my, unsigned char flg){
	BOM *lp;

	for(lp=bom_head.next; lp!=NULL; lp=lp->next){
		//キャラ移動があった場合は座標更新
		if(flg){lp->x-=mx; lp->y-=my;}

		//飛行中
		if(lp->flg == 1){
			lp->x += cos(lp->rad) * BOM_SP;	//座標更新
			lp->y += sin(lp->rad) * BOM_SP;	//　〃
			lp->carry += BOM_SP;	//飛距離加算
			if(lp->carry >= lp->range){	//飛び終えると[着地]状態
				PlaySound(&soundpac.bom_set);	//サウンド
				lp->flg=2;
				lp->anime=0;
			}
			lp->time--;	//時間減算
			if(lp->time <= 0){lp->flg=3; lp->anime=0;}	//時間切れたら爆発
		}
		//着地
		else if(lp->flg == 2){
			lp->anime = (lp->anime + 1) % 80;
			lp->time--;	//時間減算
			if(lp->time <= 0){	//時間切れたら爆発
				PlaySound(&soundpac.bom);	//サウンド
				lp->flg=3;
				lp->anime=0;
			}
		}
		//爆発
		else if(lp->flg == 3){
			lp->anime++;
			if(lp->anime >= 8){lp->flg = 0;}	//爆発終わったら消去
		}
	}

}
//描画
void DrawBom(SDL_Surface *screen, SDL_Surface *img){
	BOM *lp;

	for(lp=bom_head.next; lp!=NULL; lp=lp->next){
		//飛行中
		if(lp->flg == 1){
			DrawBmp(screen, lp->x-16, lp->y-16, 32, 32, img, 128, 608, 32, 32);
		}
		//着地
		else if(lp->flg == 2){
			DrawBmp(screen, lp->x-16, lp->y-16, 32, 32, img, 128+(lp->anime/20)*32, 608, 32, 32);
		}
		//爆発
		else if(lp->flg == 3){
			DrawBmp(screen, lp->x-16, lp->y-16, 32, 32, img, 128+(lp->anime/2)*32, 576, 32, 32);
		}
	}

}
//消去
void DeleteBom(void){
	BOM *lp, *lpSave;

	lp = bom_head.next;
	lpSave = &bom_head;
	while(lp!=NULL){
		if(!lp->flg){
			lpSave->next = lp->next;
			free(lp);
			lp = lpSave->next;
			continue;
		}
		lpSave = lp;
		lp = lp->next;
	}

}
//全消去
void AllDelBom(void){
	BOM *lp, *lpSave;

	lp = bom_head.next;
	while(lp!=NULL){
		lpSave = lp->next;
		free(lp);
		lp = lpSave;
	}
	bom_head.next = NULL;
}
//ボム＆ALLあたり
void HitBom(PLAYER *player){
	BOM *lp_bom;
	ENEMY *lp_en;

	for(lp_bom=bom_head.next; lp_bom!=NULL; lp_bom=lp_bom->next){
		//ボムが[爆発]なら
		if(lp_bom->flg == 3){
			//→プレーヤー
			if(player->flg==1 || player->flg==2){
				if(HitCircle(lp_bom->x,lp_bom->y,BOM_RANGE, PL_X+16,PL_Y+16,16)){
					PlaySound(&soundpac.bom_damage);	//サウンド
					player->hp -= BOM_POWER;
					if(player->hp<=0){	//死んでたら
						PlaySound(&soundpac.dead);	//サウンド
						player->hp = 0;
						player->koma = 0;
						player->flg = 4;
					}else{			//生きてたら(ふっ飛ぶ)
						player->flg = 3;
						player->tobi_wait = 10;
						player->tobi_muki = GetMuki(lp_bom->x, lp_bom->y, PL_X+16, PL_Y+16);
					}
				}
			}
			//→敵
			for(lp_en=enemy_head.next; lp_en!=NULL; lp_en=lp_en->next){
				if(lp_en->flg==1 || lp_en->flg==2){
					if(HitCircle(lp_bom->x,lp_bom->y,BOM_RANGE, lp_en->x+16,lp_en->y+16,16)){
						PlaySound(&soundpac.bom_damage);	//サウンド
						lp_en->hp -= BOM_POWER;
						player->score += BOM_POINT;	//スコア
						if(lp_en->hp <= 0){
							PlaySound(&soundpac.dead);	//サウンド
							lp_en->koma = 0;
							lp_en->flg = 4;
							player->score += EN_POINT;	//スコア
						}else{	//生きてたら（ふっ飛ぶ）
							lp_en->flg = 3;
							lp_en->tobi_wait = 10;
							lp_en->tobi_muki = GetMuki(lp_bom->x, lp_bom->y, lp_en->x+16, lp_en->y+16);
						}
					}
				}
			}
		}
	}
}
