#ifndef _WEAPON_H
#define _WEAPON_H

#include<SDL/SDL.h>
#include"main.h"
#include"chara.h"
#include"object.h"
#include"enemy.h"
#include"support.h"
#include"audio.h"

#define TEAM_P	0	//チーム　プレーヤー
#define TEAM_E	1	//　〃　　エネミー

#define BOM_SP	2.5	//ボムスピード
#define BOM_DELAY	5.0	//ボム起爆時間（秒）
#define BOM_POWER 30	//ボム威力
#define BOM_RANGE	30	//ボム有効範囲
#define BOM_POINT	30	//敵にボム当てたときのポイント

#define BOM_TOBI_SP	5	//ボムでふっとばされる速度

#define BULLET_POWER	8	//弾丸威力
#define BULLET_POINT	5	//敵に弾丸を当てたときのポイント


//弾丸
typedef struct BULLET{
	int x;		//x座標
	int y;		//y座標
	int anime;		//アニメ
	unsigned char flg;	//状態フラグ(0:消去 1:ダメージ 2:無害)
	unsigned char team;	//チーム分け
	struct BULLET *next;
}BULLET;

//ボム
typedef struct BOM{
	float x;	//x座標
	float y;	//y座標
	int range;	//投擲距離
	float carry;//飛行距離
	float *mag;	//描画倍率
	float rad;	//角度(ラジアン)
	int time;	//時間
	int anime;	//アニメ
	unsigned char flg;	//状態フラグ(0:消去 1:飛行 2:着地 3:爆発)
	struct BOM *next;
}BOM;

//弾丸
void MakeBullet(int x, int y, unsigned char team);	//作成
void MoveBullet(int mx, int my, unsigned char flg);	//制御
void DrawBullet(SDL_Surface *screen, SDL_Surface *img);	//描画
void DeleteBullet(void);					//消去
void AllDelBullet(void);					//全消去
void HitBullet(PLAYER *playe);		//弾丸＆ALLあたり
//ボム
void MakeBom(int x, int y, int tx, int ty);		//作成
void MoveBom(int mx, int my, unsigned char flg);	//制御
void DrawBom(SDL_Surface *screen, SDL_Surface *img);	//描画
void DeleteBom(void);						//消去
void AllDelBom(void);
void HitBom(PLAYER *player);		//ボム＆ALLあたり

#endif
